# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from microstrain_inertial_msgs/MipFilterAidingMeasurementSummary.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import microstrain_inertial_msgs.msg
import std_msgs.msg

class MipFilterAidingMeasurementSummary(genpy.Message):
  _md5sum = "d7edada71914b75e6bca6085af52e59d"
  _type = "microstrain_inertial_msgs/MipFilterAidingMeasurementSummary"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Message definition for the MIP field https://s3.amazonaws.com/files.microstrain.com/GQ7+User+Manual/external_content/dcp/Data/filter_data/data/mip_field_filter_aiding_measurement_summary.htm

# Header containing common information
#   header.frame_id has no meaning in this message
microstrain_inertial_msgs/MipHeader header

# GPS time of week (seconds)
float64 time_of_week

# Source used when type is set to TYPE_GNSS to specify which GNSS module this message is for
uint8 source

# Type of the aiding measurement. See TYPE_* enums for possible values
uint8 type

# Parsed version of indicator bitfield
microstrain_inertial_msgs/MipFilterAidingMeasurementSummaryIndicator indicator

# Possible values for type
uint8 TYPE_GNSS         = 1
uint8 TYPE_DUAL_ANTENNA = 2
uint8 TYPE_HEADING      = 3
uint8 TYPE_PRESSURE     = 4
uint8 TYPE_MAGNETOMETER = 5
uint8 TYPE_SPEED        = 6
================================================================================
MSG: microstrain_inertial_msgs/MipHeader
# Represents a standard header that all MIP fields should include at the beginning of their message definition
#   Note: This message will never be published on it's own, only included in other messages

# Standard ROS header.
#   header.stamp will always be populated with the ROS time that this message was populated
#   header.frame_id is dependent on the full message definition. Most messages will not use this
std_msgs/Header header

# If the message was triggered by an event, this will be set, otherwise it will be set to 0 (will be 0 most of the time)
# For more information, see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_event_source.htm
uint8 event_source

# Reference timestamp of when the data was sampled if the device supports it. For devices that do not support this, it will always be 0
# For more information, see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_reference_timestamp.htm
uint64 reference_timestamp

# GPS timestamp of when the data was sampled if the device supports it
# For more information, see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_gps_timestamp.htm
# Note that this timestamp may be blank in certain messages, but there will often be equivalent fields in the messages
microstrain_inertial_msgs/MipGpsTimestamp gps_timestamp
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: microstrain_inertial_msgs/MipGpsTimestamp
# Definition of a GPS timestamp.
# For more information see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_gps_timestamp.htm
#   Note: This message will never be published on it's own, only included in other messages

# GPS time of week (seconds)
float64 tow

# GPS Week number since 1980 (weeks)
uint16 week_number
================================================================================
MSG: microstrain_inertial_msgs/MipFilterAidingMeasurementSummaryIndicator
# Message definition for the indicator field of https://s3.amazonaws.com/files.microstrain.com/GQ7+User+Manual/external_content/dcp/Data/filter_data/data/mip_field_filter_aiding_measurement_summary.htm?Highlight=filter%20aiding%20measurement
#   Note: This message will never be published on it's own, only included in other messages

bool enabled
bool used
bool residual_high_warning
bool sample_time_warning
bool configuration_error
bool max_num_meas_exceeded"""
  # Pseudo-constants
  TYPE_GNSS = 1
  TYPE_DUAL_ANTENNA = 2
  TYPE_HEADING = 3
  TYPE_PRESSURE = 4
  TYPE_MAGNETOMETER = 5
  TYPE_SPEED = 6

  __slots__ = ['header','time_of_week','source','type','indicator']
  _slot_types = ['microstrain_inertial_msgs/MipHeader','float64','uint8','uint8','microstrain_inertial_msgs/MipFilterAidingMeasurementSummaryIndicator']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,time_of_week,source,type,indicator

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MipFilterAidingMeasurementSummary, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = microstrain_inertial_msgs.msg.MipHeader()
      if self.time_of_week is None:
        self.time_of_week = 0.
      if self.source is None:
        self.source = 0
      if self.type is None:
        self.type = 0
      if self.indicator is None:
        self.indicator = microstrain_inertial_msgs.msg.MipFilterAidingMeasurementSummaryIndicator()
    else:
      self.header = microstrain_inertial_msgs.msg.MipHeader()
      self.time_of_week = 0.
      self.source = 0
      self.type = 0
      self.indicator = microstrain_inertial_msgs.msg.MipFilterAidingMeasurementSummaryIndicator()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.header.seq, _x.header.header.stamp.secs, _x.header.header.stamp.nsecs))
      _x = self.header.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_BQdHd8B().pack(_x.header.event_source, _x.header.reference_timestamp, _x.header.gps_timestamp.tow, _x.header.gps_timestamp.week_number, _x.time_of_week, _x.source, _x.type, _x.indicator.enabled, _x.indicator.used, _x.indicator.residual_high_warning, _x.indicator.sample_time_warning, _x.indicator.configuration_error, _x.indicator.max_num_meas_exceeded))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = microstrain_inertial_msgs.msg.MipHeader()
      if self.indicator is None:
        self.indicator = microstrain_inertial_msgs.msg.MipFilterAidingMeasurementSummaryIndicator()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.header.seq, _x.header.header.stamp.secs, _x.header.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 35
      (_x.header.event_source, _x.header.reference_timestamp, _x.header.gps_timestamp.tow, _x.header.gps_timestamp.week_number, _x.time_of_week, _x.source, _x.type, _x.indicator.enabled, _x.indicator.used, _x.indicator.residual_high_warning, _x.indicator.sample_time_warning, _x.indicator.configuration_error, _x.indicator.max_num_meas_exceeded,) = _get_struct_BQdHd8B().unpack(str[start:end])
      self.indicator.enabled = bool(self.indicator.enabled)
      self.indicator.used = bool(self.indicator.used)
      self.indicator.residual_high_warning = bool(self.indicator.residual_high_warning)
      self.indicator.sample_time_warning = bool(self.indicator.sample_time_warning)
      self.indicator.configuration_error = bool(self.indicator.configuration_error)
      self.indicator.max_num_meas_exceeded = bool(self.indicator.max_num_meas_exceeded)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.header.seq, _x.header.header.stamp.secs, _x.header.header.stamp.nsecs))
      _x = self.header.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_BQdHd8B().pack(_x.header.event_source, _x.header.reference_timestamp, _x.header.gps_timestamp.tow, _x.header.gps_timestamp.week_number, _x.time_of_week, _x.source, _x.type, _x.indicator.enabled, _x.indicator.used, _x.indicator.residual_high_warning, _x.indicator.sample_time_warning, _x.indicator.configuration_error, _x.indicator.max_num_meas_exceeded))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = microstrain_inertial_msgs.msg.MipHeader()
      if self.indicator is None:
        self.indicator = microstrain_inertial_msgs.msg.MipFilterAidingMeasurementSummaryIndicator()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.header.seq, _x.header.header.stamp.secs, _x.header.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 35
      (_x.header.event_source, _x.header.reference_timestamp, _x.header.gps_timestamp.tow, _x.header.gps_timestamp.week_number, _x.time_of_week, _x.source, _x.type, _x.indicator.enabled, _x.indicator.used, _x.indicator.residual_high_warning, _x.indicator.sample_time_warning, _x.indicator.configuration_error, _x.indicator.max_num_meas_exceeded,) = _get_struct_BQdHd8B().unpack(str[start:end])
      self.indicator.enabled = bool(self.indicator.enabled)
      self.indicator.used = bool(self.indicator.used)
      self.indicator.residual_high_warning = bool(self.indicator.residual_high_warning)
      self.indicator.sample_time_warning = bool(self.indicator.sample_time_warning)
      self.indicator.configuration_error = bool(self.indicator.configuration_error)
      self.indicator.max_num_meas_exceeded = bool(self.indicator.max_num_meas_exceeded)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_BQdHd8B = None
def _get_struct_BQdHd8B():
    global _struct_BQdHd8B
    if _struct_BQdHd8B is None:
        _struct_BQdHd8B = struct.Struct("<BQdHd8B")
    return _struct_BQdHd8B
