# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from microstrain_inertial_msgs/MipFilterGnssDualAntennaStatus.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import microstrain_inertial_msgs.msg
import std_msgs.msg

class MipFilterGnssDualAntennaStatus(genpy.Message):
  _md5sum = "ad9908a6aa0377a5e2b9ff2dd2b27ba5"
  _type = "microstrain_inertial_msgs/MipFilterGnssDualAntennaStatus"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Message definition for the MIP field https://s3.amazonaws.com/files.microstrain.com/GQ7+User+Manual/external_content/dcp/Data/filter_data/data/mip_field_filter_gnss_dual_antenna_status.htm

# Header containing common information
#   header.frame_id has no meaning in this message
microstrain_inertial_msgs/MipHeader header

# Last dual-antenna GNSS aiding measurement time of week (seconds)
float32 time_of_week

# Heading in radians
float32 heading

# Heading uncertainty in radians
float32 heading_unc

# Fix type indicator. See FIX_TYPE_* enums for possible values
uint8 fix_type

# Parsed out version of the Status Flags bitfield
microstrain_inertial_msgs/MipFilterGnssDualAntennaStatusStatusFlags status_flags

# Valid flags (0 = invalid, 1 = valid)
uint16 valid_flags

# Possible values for fix_type
uint8 FIX_TYPE_FIX_NONE     = 0
uint8 FIX_TYPE_FIX_DA_FLOAT = 1
uint8 FIX_TYPE_FIX_DA_FIXED = 2
================================================================================
MSG: microstrain_inertial_msgs/MipHeader
# Represents a standard header that all MIP fields should include at the beginning of their message definition
#   Note: This message will never be published on it's own, only included in other messages

# Standard ROS header.
#   header.stamp will always be populated with the ROS time that this message was populated
#   header.frame_id is dependent on the full message definition. Most messages will not use this
std_msgs/Header header

# If the message was triggered by an event, this will be set, otherwise it will be set to 0 (will be 0 most of the time)
# For more information, see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_event_source.htm
uint8 event_source

# Reference timestamp of when the data was sampled if the device supports it. For devices that do not support this, it will always be 0
# For more information, see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_reference_timestamp.htm
uint64 reference_timestamp

# GPS timestamp of when the data was sampled if the device supports it
# For more information, see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_gps_timestamp.htm
# Note that this timestamp may be blank in certain messages, but there will often be equivalent fields in the messages
microstrain_inertial_msgs/MipGpsTimestamp gps_timestamp
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: microstrain_inertial_msgs/MipGpsTimestamp
# Definition of a GPS timestamp.
# For more information see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_gps_timestamp.htm
#   Note: This message will never be published on it's own, only included in other messages

# GPS time of week (seconds)
float64 tow

# GPS Week number since 1980 (weeks)
uint16 week_number
================================================================================
MSG: microstrain_inertial_msgs/MipFilterGnssDualAntennaStatusStatusFlags
# Message definition for Status Flags field of https://s3.amazonaws.com/files.microstrain.com/GQ7+User+Manual/external_content/dcp/Data/filter_data/data/mip_field_filter_gnss_dual_antenna_status.htm?Highlight=dual%20antenna
#   Note: This message will never be published on it's own, only included in other messages.

bool rcv_1_data_valid
bool rcv_2_data_valid
bool antenna_offsets_valid"""
  # Pseudo-constants
  FIX_TYPE_FIX_NONE = 0
  FIX_TYPE_FIX_DA_FLOAT = 1
  FIX_TYPE_FIX_DA_FIXED = 2

  __slots__ = ['header','time_of_week','heading','heading_unc','fix_type','status_flags','valid_flags']
  _slot_types = ['microstrain_inertial_msgs/MipHeader','float32','float32','float32','uint8','microstrain_inertial_msgs/MipFilterGnssDualAntennaStatusStatusFlags','uint16']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,time_of_week,heading,heading_unc,fix_type,status_flags,valid_flags

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MipFilterGnssDualAntennaStatus, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = microstrain_inertial_msgs.msg.MipHeader()
      if self.time_of_week is None:
        self.time_of_week = 0.
      if self.heading is None:
        self.heading = 0.
      if self.heading_unc is None:
        self.heading_unc = 0.
      if self.fix_type is None:
        self.fix_type = 0
      if self.status_flags is None:
        self.status_flags = microstrain_inertial_msgs.msg.MipFilterGnssDualAntennaStatusStatusFlags()
      if self.valid_flags is None:
        self.valid_flags = 0
    else:
      self.header = microstrain_inertial_msgs.msg.MipHeader()
      self.time_of_week = 0.
      self.heading = 0.
      self.heading_unc = 0.
      self.fix_type = 0
      self.status_flags = microstrain_inertial_msgs.msg.MipFilterGnssDualAntennaStatusStatusFlags()
      self.valid_flags = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.header.seq, _x.header.header.stamp.secs, _x.header.header.stamp.nsecs))
      _x = self.header.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_BQdH3f4BH().pack(_x.header.event_source, _x.header.reference_timestamp, _x.header.gps_timestamp.tow, _x.header.gps_timestamp.week_number, _x.time_of_week, _x.heading, _x.heading_unc, _x.fix_type, _x.status_flags.rcv_1_data_valid, _x.status_flags.rcv_2_data_valid, _x.status_flags.antenna_offsets_valid, _x.valid_flags))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = microstrain_inertial_msgs.msg.MipHeader()
      if self.status_flags is None:
        self.status_flags = microstrain_inertial_msgs.msg.MipFilterGnssDualAntennaStatusStatusFlags()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.header.seq, _x.header.header.stamp.secs, _x.header.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 37
      (_x.header.event_source, _x.header.reference_timestamp, _x.header.gps_timestamp.tow, _x.header.gps_timestamp.week_number, _x.time_of_week, _x.heading, _x.heading_unc, _x.fix_type, _x.status_flags.rcv_1_data_valid, _x.status_flags.rcv_2_data_valid, _x.status_flags.antenna_offsets_valid, _x.valid_flags,) = _get_struct_BQdH3f4BH().unpack(str[start:end])
      self.status_flags.rcv_1_data_valid = bool(self.status_flags.rcv_1_data_valid)
      self.status_flags.rcv_2_data_valid = bool(self.status_flags.rcv_2_data_valid)
      self.status_flags.antenna_offsets_valid = bool(self.status_flags.antenna_offsets_valid)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.header.seq, _x.header.header.stamp.secs, _x.header.header.stamp.nsecs))
      _x = self.header.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_BQdH3f4BH().pack(_x.header.event_source, _x.header.reference_timestamp, _x.header.gps_timestamp.tow, _x.header.gps_timestamp.week_number, _x.time_of_week, _x.heading, _x.heading_unc, _x.fix_type, _x.status_flags.rcv_1_data_valid, _x.status_flags.rcv_2_data_valid, _x.status_flags.antenna_offsets_valid, _x.valid_flags))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = microstrain_inertial_msgs.msg.MipHeader()
      if self.status_flags is None:
        self.status_flags = microstrain_inertial_msgs.msg.MipFilterGnssDualAntennaStatusStatusFlags()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.header.seq, _x.header.header.stamp.secs, _x.header.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 37
      (_x.header.event_source, _x.header.reference_timestamp, _x.header.gps_timestamp.tow, _x.header.gps_timestamp.week_number, _x.time_of_week, _x.heading, _x.heading_unc, _x.fix_type, _x.status_flags.rcv_1_data_valid, _x.status_flags.rcv_2_data_valid, _x.status_flags.antenna_offsets_valid, _x.valid_flags,) = _get_struct_BQdH3f4BH().unpack(str[start:end])
      self.status_flags.rcv_1_data_valid = bool(self.status_flags.rcv_1_data_valid)
      self.status_flags.rcv_2_data_valid = bool(self.status_flags.rcv_2_data_valid)
      self.status_flags.antenna_offsets_valid = bool(self.status_flags.antenna_offsets_valid)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_BQdH3f4BH = None
def _get_struct_BQdH3f4BH():
    global _struct_BQdH3f4BH
    if _struct_BQdH3f4BH is None:
        _struct_BQdH3f4BH = struct.Struct("<BQdH3f4BH")
    return _struct_BQdH3f4BH
