# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from microstrain_inertial_msgs/MipFilterGnssPositionAidingStatus.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import microstrain_inertial_msgs.msg
import std_msgs.msg

class MipFilterGnssPositionAidingStatus(genpy.Message):
  _md5sum = "5966560e0a0af6740c0673a99a393e66"
  _type = "microstrain_inertial_msgs/MipFilterGnssPositionAidingStatus"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Message definition for the MIP field https://s3.amazonaws.com/files.microstrain.com/GQ7+User+Manual/external_content/dcp/Data/filter_data/data/mip_field_filter_gnss_pos_aid_status.htm

# Header containing common information
#   header.frame_id has no meaning in this message
microstrain_inertial_msgs/MipHeader header

# Receiver ID. For GQ7, this will be 1 for GNSS1 and 2 for GNSS2
uint8 receiver_id

# Last GNSS aiding measurement time of week (seconds)
float64 time_of_week

# Parsed out version of the status bit field
microstrain_inertial_msgs/MipFilterGnssPositionAidingStatusStatus status
================================================================================
MSG: microstrain_inertial_msgs/MipHeader
# Represents a standard header that all MIP fields should include at the beginning of their message definition
#   Note: This message will never be published on it's own, only included in other messages

# Standard ROS header.
#   header.stamp will always be populated with the ROS time that this message was populated
#   header.frame_id is dependent on the full message definition. Most messages will not use this
std_msgs/Header header

# If the message was triggered by an event, this will be set, otherwise it will be set to 0 (will be 0 most of the time)
# For more information, see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_event_source.htm
uint8 event_source

# Reference timestamp of when the data was sampled if the device supports it. For devices that do not support this, it will always be 0
# For more information, see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_reference_timestamp.htm
uint64 reference_timestamp

# GPS timestamp of when the data was sampled if the device supports it
# For more information, see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_gps_timestamp.htm
# Note that this timestamp may be blank in certain messages, but there will often be equivalent fields in the messages
microstrain_inertial_msgs/MipGpsTimestamp gps_timestamp
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: microstrain_inertial_msgs/MipGpsTimestamp
# Definition of a GPS timestamp.
# For more information see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_gps_timestamp.htm
#   Note: This message will never be published on it's own, only included in other messages

# GPS time of week (seconds)
float64 tow

# GPS Week number since 1980 (weeks)
uint16 week_number
================================================================================
MSG: microstrain_inertial_msgs/MipFilterGnssPositionAidingStatusStatus
# Message definition for the Status field of https://s3.amazonaws.com/files.microstrain.com/GQ7+User+Manual/external_content/dcp/Data/filter_data/data/mip_field_filter_gnss_pos_aid_status.htm?Highlight=gnss%20position%20aiding
#   Note: This message will never be published on it's own, only included in other messages.

bool tight_coupling  # If 1, the Kalman filter is processing raw range information from this GNSS module
bool differential    # If 1, the Kalman filter is processing RTK corrections from this GNSS module
bool integer_fix     # If 1, the Kalman filter has an RTK integer fix from this GNSS module, indicating the best position performance possible
bool gps_l1          # If 1, the Kalman filter is using GPS L1 measurements
bool gps_l2          # If 1, the Kalman filter is using GPS L2 measurements
bool gps_l5          # If 1, the Kalman filter is using GPS L5 measurements
bool glo_l1          # If 1, the Kalman filter is using GLONASS L1 measurements
bool glo_l2          # If 1, the Kalman filter is using GLONASS L2 measurements
bool gal_e1          # If 1, the Kalman filter is using Galileo E1 measurements
bool gal_e5          # If 1, the Kalman filter is using Galileo E5 measurements
bool gal_e6          # If 1, the Kalman filter is using Galileo E6 measurements
bool bei_b1          # If 1, the Kalman filter is using Beidou B1 measurements (not enabled on GQ7 currently)
bool bei_b2          # If 1, the Kalman filter is using Beidou B2 measurements (not enabled on GQ7 currently)
bool bei_b3          # If 1, the Kalman filter is using Beidou B3 measurements (not enabled on GQ7 currently)
bool no_fix          # If 1, this GNSS module is reporting no position fix
bool config_error    # If 1, there is likely an issue with the antenna offset for this GNSS module"""
  __slots__ = ['header','receiver_id','time_of_week','status']
  _slot_types = ['microstrain_inertial_msgs/MipHeader','uint8','float64','microstrain_inertial_msgs/MipFilterGnssPositionAidingStatusStatus']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,receiver_id,time_of_week,status

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MipFilterGnssPositionAidingStatus, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = microstrain_inertial_msgs.msg.MipHeader()
      if self.receiver_id is None:
        self.receiver_id = 0
      if self.time_of_week is None:
        self.time_of_week = 0.
      if self.status is None:
        self.status = microstrain_inertial_msgs.msg.MipFilterGnssPositionAidingStatusStatus()
    else:
      self.header = microstrain_inertial_msgs.msg.MipHeader()
      self.receiver_id = 0
      self.time_of_week = 0.
      self.status = microstrain_inertial_msgs.msg.MipFilterGnssPositionAidingStatusStatus()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.header.seq, _x.header.header.stamp.secs, _x.header.header.stamp.nsecs))
      _x = self.header.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_BQdHBd16B().pack(_x.header.event_source, _x.header.reference_timestamp, _x.header.gps_timestamp.tow, _x.header.gps_timestamp.week_number, _x.receiver_id, _x.time_of_week, _x.status.tight_coupling, _x.status.differential, _x.status.integer_fix, _x.status.gps_l1, _x.status.gps_l2, _x.status.gps_l5, _x.status.glo_l1, _x.status.glo_l2, _x.status.gal_e1, _x.status.gal_e5, _x.status.gal_e6, _x.status.bei_b1, _x.status.bei_b2, _x.status.bei_b3, _x.status.no_fix, _x.status.config_error))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = microstrain_inertial_msgs.msg.MipHeader()
      if self.status is None:
        self.status = microstrain_inertial_msgs.msg.MipFilterGnssPositionAidingStatusStatus()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.header.seq, _x.header.header.stamp.secs, _x.header.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 44
      (_x.header.event_source, _x.header.reference_timestamp, _x.header.gps_timestamp.tow, _x.header.gps_timestamp.week_number, _x.receiver_id, _x.time_of_week, _x.status.tight_coupling, _x.status.differential, _x.status.integer_fix, _x.status.gps_l1, _x.status.gps_l2, _x.status.gps_l5, _x.status.glo_l1, _x.status.glo_l2, _x.status.gal_e1, _x.status.gal_e5, _x.status.gal_e6, _x.status.bei_b1, _x.status.bei_b2, _x.status.bei_b3, _x.status.no_fix, _x.status.config_error,) = _get_struct_BQdHBd16B().unpack(str[start:end])
      self.status.tight_coupling = bool(self.status.tight_coupling)
      self.status.differential = bool(self.status.differential)
      self.status.integer_fix = bool(self.status.integer_fix)
      self.status.gps_l1 = bool(self.status.gps_l1)
      self.status.gps_l2 = bool(self.status.gps_l2)
      self.status.gps_l5 = bool(self.status.gps_l5)
      self.status.glo_l1 = bool(self.status.glo_l1)
      self.status.glo_l2 = bool(self.status.glo_l2)
      self.status.gal_e1 = bool(self.status.gal_e1)
      self.status.gal_e5 = bool(self.status.gal_e5)
      self.status.gal_e6 = bool(self.status.gal_e6)
      self.status.bei_b1 = bool(self.status.bei_b1)
      self.status.bei_b2 = bool(self.status.bei_b2)
      self.status.bei_b3 = bool(self.status.bei_b3)
      self.status.no_fix = bool(self.status.no_fix)
      self.status.config_error = bool(self.status.config_error)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.header.seq, _x.header.header.stamp.secs, _x.header.header.stamp.nsecs))
      _x = self.header.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_BQdHBd16B().pack(_x.header.event_source, _x.header.reference_timestamp, _x.header.gps_timestamp.tow, _x.header.gps_timestamp.week_number, _x.receiver_id, _x.time_of_week, _x.status.tight_coupling, _x.status.differential, _x.status.integer_fix, _x.status.gps_l1, _x.status.gps_l2, _x.status.gps_l5, _x.status.glo_l1, _x.status.glo_l2, _x.status.gal_e1, _x.status.gal_e5, _x.status.gal_e6, _x.status.bei_b1, _x.status.bei_b2, _x.status.bei_b3, _x.status.no_fix, _x.status.config_error))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = microstrain_inertial_msgs.msg.MipHeader()
      if self.status is None:
        self.status = microstrain_inertial_msgs.msg.MipFilterGnssPositionAidingStatusStatus()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.header.seq, _x.header.header.stamp.secs, _x.header.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 44
      (_x.header.event_source, _x.header.reference_timestamp, _x.header.gps_timestamp.tow, _x.header.gps_timestamp.week_number, _x.receiver_id, _x.time_of_week, _x.status.tight_coupling, _x.status.differential, _x.status.integer_fix, _x.status.gps_l1, _x.status.gps_l2, _x.status.gps_l5, _x.status.glo_l1, _x.status.glo_l2, _x.status.gal_e1, _x.status.gal_e5, _x.status.gal_e6, _x.status.bei_b1, _x.status.bei_b2, _x.status.bei_b3, _x.status.no_fix, _x.status.config_error,) = _get_struct_BQdHBd16B().unpack(str[start:end])
      self.status.tight_coupling = bool(self.status.tight_coupling)
      self.status.differential = bool(self.status.differential)
      self.status.integer_fix = bool(self.status.integer_fix)
      self.status.gps_l1 = bool(self.status.gps_l1)
      self.status.gps_l2 = bool(self.status.gps_l2)
      self.status.gps_l5 = bool(self.status.gps_l5)
      self.status.glo_l1 = bool(self.status.glo_l1)
      self.status.glo_l2 = bool(self.status.glo_l2)
      self.status.gal_e1 = bool(self.status.gal_e1)
      self.status.gal_e5 = bool(self.status.gal_e5)
      self.status.gal_e6 = bool(self.status.gal_e6)
      self.status.bei_b1 = bool(self.status.bei_b1)
      self.status.bei_b2 = bool(self.status.bei_b2)
      self.status.bei_b3 = bool(self.status.bei_b3)
      self.status.no_fix = bool(self.status.no_fix)
      self.status.config_error = bool(self.status.config_error)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_BQdHBd16B = None
def _get_struct_BQdHBd16B():
    global _struct_BQdHBd16B
    if _struct_BQdHBd16B is None:
        _struct_BQdHBd16B = struct.Struct("<BQdHBd16B")
    return _struct_BQdHBd16B
