# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from microstrain_inertial_msgs/MipFilterGnssPositionAidingStatusStatus.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class MipFilterGnssPositionAidingStatusStatus(genpy.Message):
  _md5sum = "16a70154d04cba5f7c01e663ddb16c49"
  _type = "microstrain_inertial_msgs/MipFilterGnssPositionAidingStatusStatus"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Message definition for the Status field of https://s3.amazonaws.com/files.microstrain.com/GQ7+User+Manual/external_content/dcp/Data/filter_data/data/mip_field_filter_gnss_pos_aid_status.htm?Highlight=gnss%20position%20aiding
#   Note: This message will never be published on it's own, only included in other messages.

bool tight_coupling  # If 1, the Kalman filter is processing raw range information from this GNSS module
bool differential    # If 1, the Kalman filter is processing RTK corrections from this GNSS module
bool integer_fix     # If 1, the Kalman filter has an RTK integer fix from this GNSS module, indicating the best position performance possible
bool gps_l1          # If 1, the Kalman filter is using GPS L1 measurements
bool gps_l2          # If 1, the Kalman filter is using GPS L2 measurements
bool gps_l5          # If 1, the Kalman filter is using GPS L5 measurements
bool glo_l1          # If 1, the Kalman filter is using GLONASS L1 measurements
bool glo_l2          # If 1, the Kalman filter is using GLONASS L2 measurements
bool gal_e1          # If 1, the Kalman filter is using Galileo E1 measurements
bool gal_e5          # If 1, the Kalman filter is using Galileo E5 measurements
bool gal_e6          # If 1, the Kalman filter is using Galileo E6 measurements
bool bei_b1          # If 1, the Kalman filter is using Beidou B1 measurements (not enabled on GQ7 currently)
bool bei_b2          # If 1, the Kalman filter is using Beidou B2 measurements (not enabled on GQ7 currently)
bool bei_b3          # If 1, the Kalman filter is using Beidou B3 measurements (not enabled on GQ7 currently)
bool no_fix          # If 1, this GNSS module is reporting no position fix
bool config_error    # If 1, there is likely an issue with the antenna offset for this GNSS module"""
  __slots__ = ['tight_coupling','differential','integer_fix','gps_l1','gps_l2','gps_l5','glo_l1','glo_l2','gal_e1','gal_e5','gal_e6','bei_b1','bei_b2','bei_b3','no_fix','config_error']
  _slot_types = ['bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       tight_coupling,differential,integer_fix,gps_l1,gps_l2,gps_l5,glo_l1,glo_l2,gal_e1,gal_e5,gal_e6,bei_b1,bei_b2,bei_b3,no_fix,config_error

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MipFilterGnssPositionAidingStatusStatus, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.tight_coupling is None:
        self.tight_coupling = False
      if self.differential is None:
        self.differential = False
      if self.integer_fix is None:
        self.integer_fix = False
      if self.gps_l1 is None:
        self.gps_l1 = False
      if self.gps_l2 is None:
        self.gps_l2 = False
      if self.gps_l5 is None:
        self.gps_l5 = False
      if self.glo_l1 is None:
        self.glo_l1 = False
      if self.glo_l2 is None:
        self.glo_l2 = False
      if self.gal_e1 is None:
        self.gal_e1 = False
      if self.gal_e5 is None:
        self.gal_e5 = False
      if self.gal_e6 is None:
        self.gal_e6 = False
      if self.bei_b1 is None:
        self.bei_b1 = False
      if self.bei_b2 is None:
        self.bei_b2 = False
      if self.bei_b3 is None:
        self.bei_b3 = False
      if self.no_fix is None:
        self.no_fix = False
      if self.config_error is None:
        self.config_error = False
    else:
      self.tight_coupling = False
      self.differential = False
      self.integer_fix = False
      self.gps_l1 = False
      self.gps_l2 = False
      self.gps_l5 = False
      self.glo_l1 = False
      self.glo_l2 = False
      self.gal_e1 = False
      self.gal_e5 = False
      self.gal_e6 = False
      self.bei_b1 = False
      self.bei_b2 = False
      self.bei_b3 = False
      self.no_fix = False
      self.config_error = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_16B().pack(_x.tight_coupling, _x.differential, _x.integer_fix, _x.gps_l1, _x.gps_l2, _x.gps_l5, _x.glo_l1, _x.glo_l2, _x.gal_e1, _x.gal_e5, _x.gal_e6, _x.bei_b1, _x.bei_b2, _x.bei_b3, _x.no_fix, _x.config_error))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 16
      (_x.tight_coupling, _x.differential, _x.integer_fix, _x.gps_l1, _x.gps_l2, _x.gps_l5, _x.glo_l1, _x.glo_l2, _x.gal_e1, _x.gal_e5, _x.gal_e6, _x.bei_b1, _x.bei_b2, _x.bei_b3, _x.no_fix, _x.config_error,) = _get_struct_16B().unpack(str[start:end])
      self.tight_coupling = bool(self.tight_coupling)
      self.differential = bool(self.differential)
      self.integer_fix = bool(self.integer_fix)
      self.gps_l1 = bool(self.gps_l1)
      self.gps_l2 = bool(self.gps_l2)
      self.gps_l5 = bool(self.gps_l5)
      self.glo_l1 = bool(self.glo_l1)
      self.glo_l2 = bool(self.glo_l2)
      self.gal_e1 = bool(self.gal_e1)
      self.gal_e5 = bool(self.gal_e5)
      self.gal_e6 = bool(self.gal_e6)
      self.bei_b1 = bool(self.bei_b1)
      self.bei_b2 = bool(self.bei_b2)
      self.bei_b3 = bool(self.bei_b3)
      self.no_fix = bool(self.no_fix)
      self.config_error = bool(self.config_error)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_16B().pack(_x.tight_coupling, _x.differential, _x.integer_fix, _x.gps_l1, _x.gps_l2, _x.gps_l5, _x.glo_l1, _x.glo_l2, _x.gal_e1, _x.gal_e5, _x.gal_e6, _x.bei_b1, _x.bei_b2, _x.bei_b3, _x.no_fix, _x.config_error))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 16
      (_x.tight_coupling, _x.differential, _x.integer_fix, _x.gps_l1, _x.gps_l2, _x.gps_l5, _x.glo_l1, _x.glo_l2, _x.gal_e1, _x.gal_e5, _x.gal_e6, _x.bei_b1, _x.bei_b2, _x.bei_b3, _x.no_fix, _x.config_error,) = _get_struct_16B().unpack(str[start:end])
      self.tight_coupling = bool(self.tight_coupling)
      self.differential = bool(self.differential)
      self.integer_fix = bool(self.integer_fix)
      self.gps_l1 = bool(self.gps_l1)
      self.gps_l2 = bool(self.gps_l2)
      self.gps_l5 = bool(self.gps_l5)
      self.glo_l1 = bool(self.glo_l1)
      self.glo_l2 = bool(self.glo_l2)
      self.gal_e1 = bool(self.gal_e1)
      self.gal_e5 = bool(self.gal_e5)
      self.gal_e6 = bool(self.gal_e6)
      self.bei_b1 = bool(self.bei_b1)
      self.bei_b2 = bool(self.bei_b2)
      self.bei_b3 = bool(self.bei_b3)
      self.no_fix = bool(self.no_fix)
      self.config_error = bool(self.config_error)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_16B = None
def _get_struct_16B():
    global _struct_16B
    if _struct_16B is None:
        _struct_16B = struct.Struct("<16B")
    return _struct_16B
