# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from microstrain_inertial_msgs/MipFilterStatus.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import microstrain_inertial_msgs.msg
import std_msgs.msg

class MipFilterStatus(genpy.Message):
  _md5sum = "e9679d8a6e2a873f1e5d6301921d4292"
  _type = "microstrain_inertial_msgs/MipFilterStatus"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Message definition for the MIP field https://s3.amazonaws.com/files.microstrain.com/GQ7+User+Manual/external_content/dcp/Data/filter_data/data/mip_field_filter_status.htm

# Header containing common information
#   header.frame_id has no meaning in this message
microstrain_inertial_msgs/MipHeader header

# Device-specific filter state. Please consult the user manual for definition. See FILTER_STATE_* enums for possible values
uint16 filter_state

# Device-specific dynamics mode. Please consult the user manual for definition. See DYNAMICS_MODE_* enums for possible values
# Note that for prospect devices (GQ7, CV7, etc), this field has a default value, and should be mostly ignored
uint16 dynamics_mode

# Parsed out version of the Status Flags bitfield when the connected device is a philo device (GX5, CX5, CV5, etc)
microstrain_inertial_msgs/MipFilterStatusGx5StatusFlags gx5_status_flags

# Parsed out version of the Status Flags bitfield when the connected device is a prospect device (GQ7, CV7, etc)
microstrain_inertial_msgs/MipFilterStatusGq7StatusFlags gq7_status_flags

# Possible values for filter_state when the connected device is a philo device (GX5, CX5, CV5, etc)
uint16 FILTER_STATE_GX5_STARTUP            = 0
uint16 FILTER_STATE_GX5_INIT               = 1
uint16 FILTER_STATE_GX5_RUN_SOLUTION_VALID = 2
uint16 FILTER_STATE_GX5_RUN_SOLUTION_ERROR = 3

# Possible values for filter_state when the connected device is a prospect device (GQ7, CV7, etc)
uint16 FILTER_STATE_GQ7_INIT      = 1
uint16 FILTER_STATE_GQ7_VERT_GYRO = 2
uint16 FILTER_STATE_GQ7_AHRS      = 3
uint16 FILTER_STATE_GQ7_FULL_NAV  = 4

# Possible values for dynamics_mode when the connected device is a philo device (GX5, CX5, CV5, etc)
uint16 DYNAMICS_MODE_GX5_PORTABLE   = 1
uint16 DYNAMICS_MODE_GX5_AUTOMOTIVE = 2
uint16 DYNAMICS_MODE_GX5_AIRBORNE   = 3

# Possible values for dynamics_mode when the connected device is a prospect device (GQ7, CV7, etc)
# Note that on older firmware the GQ7 will often report 0 for it's dynamics mode, it is strongly advised to ignore this field
uint16 DYNAMICS_MODE_GQ7_DEFAULT = 1
================================================================================
MSG: microstrain_inertial_msgs/MipHeader
# Represents a standard header that all MIP fields should include at the beginning of their message definition
#   Note: This message will never be published on it's own, only included in other messages

# Standard ROS header.
#   header.stamp will always be populated with the ROS time that this message was populated
#   header.frame_id is dependent on the full message definition. Most messages will not use this
std_msgs/Header header

# If the message was triggered by an event, this will be set, otherwise it will be set to 0 (will be 0 most of the time)
# For more information, see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_event_source.htm
uint8 event_source

# Reference timestamp of when the data was sampled if the device supports it. For devices that do not support this, it will always be 0
# For more information, see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_reference_timestamp.htm
uint64 reference_timestamp

# GPS timestamp of when the data was sampled if the device supports it
# For more information, see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_gps_timestamp.htm
# Note that this timestamp may be blank in certain messages, but there will often be equivalent fields in the messages
microstrain_inertial_msgs/MipGpsTimestamp gps_timestamp
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: microstrain_inertial_msgs/MipGpsTimestamp
# Definition of a GPS timestamp.
# For more information see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_gps_timestamp.htm
#   Note: This message will never be published on it's own, only included in other messages

# GPS time of week (seconds)
float64 tow

# GPS Week number since 1980 (weeks)
uint16 week_number
================================================================================
MSG: microstrain_inertial_msgs/MipFilterStatusGx5StatusFlags
# Message definition for the Status Flags (GX5, CV5, CX5, etc.) field of https://s3.amazonaws.com/files.microstrain.com/GQ7+User+Manual/external_content/dcp/Data/filter_data/data/mip_field_filter_status.htm?Highlight=filter%20status
#   Note: This message will never be published on it's own, only included in other messages.

bool init_no_attitude
bool init_no_position_velocity
bool run_imu_unavailable
bool run_gps_unavailable
bool run_matrix_singularity
bool run_position_covariance_warning
bool run_velocity_covariance_warning
bool run_attitude_covariance_warning
bool run_nan_in_solution_warning
bool run_gyro_bias_est_high_warning
bool run_accel_bias_est_high_warning
bool run_gyro_scale_factor_est_high_warning
bool run_accel_scale_factor_est_high_warning
bool run_mag_bias_est_high_warning
bool run_ant_offset_correction_est_high_warning
bool run_mag_hard_iron_est_high_warning
bool run_mag_soft_iron_est_high_warning
================================================================================
MSG: microstrain_inertial_msgs/MipFilterStatusGq7StatusFlags
# Message definition for the Status Flags (GQ7, CV7, etc.) field of https://s3.amazonaws.com/files.microstrain.com/GQ7+User+Manual/external_content/dcp/Data/filter_data/data/mip_field_filter_status.htm?Highlight=filter%20status
#   Note: This message will never be published on it's own, only included in other messages.

uint8 filter_condition  # See FILTER_CONDITION_* enums for possible values
bool  roll_pitch_warning
bool  heading_warning
bool  position_warning
bool  velocity_warning
bool  imu_bias_warning
bool  gnss_clk_warning
bool  antenna_lever_arm_warning
bool  mounting_transform_warning
bool  time_sync_warning  # No time synchronization pulse detected
bool  solution_error  # This includes all bits between 12 and 15, if any of them are set there is a GQ7 solution error

# Possible values for filter_condition when the connected device is a prospect device (GQ7, CV7, etc)
uint8 FILTER_CONDITION_STABLE     = 1
uint8 FILTER_CONDITION_CONVERGING = 2
uint8 FILTER_CONDITION_UNSTABLE   = 3"""
  # Pseudo-constants
  FILTER_STATE_GX5_STARTUP = 0
  FILTER_STATE_GX5_INIT = 1
  FILTER_STATE_GX5_RUN_SOLUTION_VALID = 2
  FILTER_STATE_GX5_RUN_SOLUTION_ERROR = 3
  FILTER_STATE_GQ7_INIT = 1
  FILTER_STATE_GQ7_VERT_GYRO = 2
  FILTER_STATE_GQ7_AHRS = 3
  FILTER_STATE_GQ7_FULL_NAV = 4
  DYNAMICS_MODE_GX5_PORTABLE = 1
  DYNAMICS_MODE_GX5_AUTOMOTIVE = 2
  DYNAMICS_MODE_GX5_AIRBORNE = 3
  DYNAMICS_MODE_GQ7_DEFAULT = 1

  __slots__ = ['header','filter_state','dynamics_mode','gx5_status_flags','gq7_status_flags']
  _slot_types = ['microstrain_inertial_msgs/MipHeader','uint16','uint16','microstrain_inertial_msgs/MipFilterStatusGx5StatusFlags','microstrain_inertial_msgs/MipFilterStatusGq7StatusFlags']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,filter_state,dynamics_mode,gx5_status_flags,gq7_status_flags

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MipFilterStatus, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = microstrain_inertial_msgs.msg.MipHeader()
      if self.filter_state is None:
        self.filter_state = 0
      if self.dynamics_mode is None:
        self.dynamics_mode = 0
      if self.gx5_status_flags is None:
        self.gx5_status_flags = microstrain_inertial_msgs.msg.MipFilterStatusGx5StatusFlags()
      if self.gq7_status_flags is None:
        self.gq7_status_flags = microstrain_inertial_msgs.msg.MipFilterStatusGq7StatusFlags()
    else:
      self.header = microstrain_inertial_msgs.msg.MipHeader()
      self.filter_state = 0
      self.dynamics_mode = 0
      self.gx5_status_flags = microstrain_inertial_msgs.msg.MipFilterStatusGx5StatusFlags()
      self.gq7_status_flags = microstrain_inertial_msgs.msg.MipFilterStatusGq7StatusFlags()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.header.seq, _x.header.header.stamp.secs, _x.header.header.stamp.nsecs))
      _x = self.header.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_BQd3H28B().pack(_x.header.event_source, _x.header.reference_timestamp, _x.header.gps_timestamp.tow, _x.header.gps_timestamp.week_number, _x.filter_state, _x.dynamics_mode, _x.gx5_status_flags.init_no_attitude, _x.gx5_status_flags.init_no_position_velocity, _x.gx5_status_flags.run_imu_unavailable, _x.gx5_status_flags.run_gps_unavailable, _x.gx5_status_flags.run_matrix_singularity, _x.gx5_status_flags.run_position_covariance_warning, _x.gx5_status_flags.run_velocity_covariance_warning, _x.gx5_status_flags.run_attitude_covariance_warning, _x.gx5_status_flags.run_nan_in_solution_warning, _x.gx5_status_flags.run_gyro_bias_est_high_warning, _x.gx5_status_flags.run_accel_bias_est_high_warning, _x.gx5_status_flags.run_gyro_scale_factor_est_high_warning, _x.gx5_status_flags.run_accel_scale_factor_est_high_warning, _x.gx5_status_flags.run_mag_bias_est_high_warning, _x.gx5_status_flags.run_ant_offset_correction_est_high_warning, _x.gx5_status_flags.run_mag_hard_iron_est_high_warning, _x.gx5_status_flags.run_mag_soft_iron_est_high_warning, _x.gq7_status_flags.filter_condition, _x.gq7_status_flags.roll_pitch_warning, _x.gq7_status_flags.heading_warning, _x.gq7_status_flags.position_warning, _x.gq7_status_flags.velocity_warning, _x.gq7_status_flags.imu_bias_warning, _x.gq7_status_flags.gnss_clk_warning, _x.gq7_status_flags.antenna_lever_arm_warning, _x.gq7_status_flags.mounting_transform_warning, _x.gq7_status_flags.time_sync_warning, _x.gq7_status_flags.solution_error))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = microstrain_inertial_msgs.msg.MipHeader()
      if self.gx5_status_flags is None:
        self.gx5_status_flags = microstrain_inertial_msgs.msg.MipFilterStatusGx5StatusFlags()
      if self.gq7_status_flags is None:
        self.gq7_status_flags = microstrain_inertial_msgs.msg.MipFilterStatusGq7StatusFlags()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.header.seq, _x.header.header.stamp.secs, _x.header.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 51
      (_x.header.event_source, _x.header.reference_timestamp, _x.header.gps_timestamp.tow, _x.header.gps_timestamp.week_number, _x.filter_state, _x.dynamics_mode, _x.gx5_status_flags.init_no_attitude, _x.gx5_status_flags.init_no_position_velocity, _x.gx5_status_flags.run_imu_unavailable, _x.gx5_status_flags.run_gps_unavailable, _x.gx5_status_flags.run_matrix_singularity, _x.gx5_status_flags.run_position_covariance_warning, _x.gx5_status_flags.run_velocity_covariance_warning, _x.gx5_status_flags.run_attitude_covariance_warning, _x.gx5_status_flags.run_nan_in_solution_warning, _x.gx5_status_flags.run_gyro_bias_est_high_warning, _x.gx5_status_flags.run_accel_bias_est_high_warning, _x.gx5_status_flags.run_gyro_scale_factor_est_high_warning, _x.gx5_status_flags.run_accel_scale_factor_est_high_warning, _x.gx5_status_flags.run_mag_bias_est_high_warning, _x.gx5_status_flags.run_ant_offset_correction_est_high_warning, _x.gx5_status_flags.run_mag_hard_iron_est_high_warning, _x.gx5_status_flags.run_mag_soft_iron_est_high_warning, _x.gq7_status_flags.filter_condition, _x.gq7_status_flags.roll_pitch_warning, _x.gq7_status_flags.heading_warning, _x.gq7_status_flags.position_warning, _x.gq7_status_flags.velocity_warning, _x.gq7_status_flags.imu_bias_warning, _x.gq7_status_flags.gnss_clk_warning, _x.gq7_status_flags.antenna_lever_arm_warning, _x.gq7_status_flags.mounting_transform_warning, _x.gq7_status_flags.time_sync_warning, _x.gq7_status_flags.solution_error,) = _get_struct_BQd3H28B().unpack(str[start:end])
      self.gx5_status_flags.init_no_attitude = bool(self.gx5_status_flags.init_no_attitude)
      self.gx5_status_flags.init_no_position_velocity = bool(self.gx5_status_flags.init_no_position_velocity)
      self.gx5_status_flags.run_imu_unavailable = bool(self.gx5_status_flags.run_imu_unavailable)
      self.gx5_status_flags.run_gps_unavailable = bool(self.gx5_status_flags.run_gps_unavailable)
      self.gx5_status_flags.run_matrix_singularity = bool(self.gx5_status_flags.run_matrix_singularity)
      self.gx5_status_flags.run_position_covariance_warning = bool(self.gx5_status_flags.run_position_covariance_warning)
      self.gx5_status_flags.run_velocity_covariance_warning = bool(self.gx5_status_flags.run_velocity_covariance_warning)
      self.gx5_status_flags.run_attitude_covariance_warning = bool(self.gx5_status_flags.run_attitude_covariance_warning)
      self.gx5_status_flags.run_nan_in_solution_warning = bool(self.gx5_status_flags.run_nan_in_solution_warning)
      self.gx5_status_flags.run_gyro_bias_est_high_warning = bool(self.gx5_status_flags.run_gyro_bias_est_high_warning)
      self.gx5_status_flags.run_accel_bias_est_high_warning = bool(self.gx5_status_flags.run_accel_bias_est_high_warning)
      self.gx5_status_flags.run_gyro_scale_factor_est_high_warning = bool(self.gx5_status_flags.run_gyro_scale_factor_est_high_warning)
      self.gx5_status_flags.run_accel_scale_factor_est_high_warning = bool(self.gx5_status_flags.run_accel_scale_factor_est_high_warning)
      self.gx5_status_flags.run_mag_bias_est_high_warning = bool(self.gx5_status_flags.run_mag_bias_est_high_warning)
      self.gx5_status_flags.run_ant_offset_correction_est_high_warning = bool(self.gx5_status_flags.run_ant_offset_correction_est_high_warning)
      self.gx5_status_flags.run_mag_hard_iron_est_high_warning = bool(self.gx5_status_flags.run_mag_hard_iron_est_high_warning)
      self.gx5_status_flags.run_mag_soft_iron_est_high_warning = bool(self.gx5_status_flags.run_mag_soft_iron_est_high_warning)
      self.gq7_status_flags.roll_pitch_warning = bool(self.gq7_status_flags.roll_pitch_warning)
      self.gq7_status_flags.heading_warning = bool(self.gq7_status_flags.heading_warning)
      self.gq7_status_flags.position_warning = bool(self.gq7_status_flags.position_warning)
      self.gq7_status_flags.velocity_warning = bool(self.gq7_status_flags.velocity_warning)
      self.gq7_status_flags.imu_bias_warning = bool(self.gq7_status_flags.imu_bias_warning)
      self.gq7_status_flags.gnss_clk_warning = bool(self.gq7_status_flags.gnss_clk_warning)
      self.gq7_status_flags.antenna_lever_arm_warning = bool(self.gq7_status_flags.antenna_lever_arm_warning)
      self.gq7_status_flags.mounting_transform_warning = bool(self.gq7_status_flags.mounting_transform_warning)
      self.gq7_status_flags.time_sync_warning = bool(self.gq7_status_flags.time_sync_warning)
      self.gq7_status_flags.solution_error = bool(self.gq7_status_flags.solution_error)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.header.seq, _x.header.header.stamp.secs, _x.header.header.stamp.nsecs))
      _x = self.header.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_BQd3H28B().pack(_x.header.event_source, _x.header.reference_timestamp, _x.header.gps_timestamp.tow, _x.header.gps_timestamp.week_number, _x.filter_state, _x.dynamics_mode, _x.gx5_status_flags.init_no_attitude, _x.gx5_status_flags.init_no_position_velocity, _x.gx5_status_flags.run_imu_unavailable, _x.gx5_status_flags.run_gps_unavailable, _x.gx5_status_flags.run_matrix_singularity, _x.gx5_status_flags.run_position_covariance_warning, _x.gx5_status_flags.run_velocity_covariance_warning, _x.gx5_status_flags.run_attitude_covariance_warning, _x.gx5_status_flags.run_nan_in_solution_warning, _x.gx5_status_flags.run_gyro_bias_est_high_warning, _x.gx5_status_flags.run_accel_bias_est_high_warning, _x.gx5_status_flags.run_gyro_scale_factor_est_high_warning, _x.gx5_status_flags.run_accel_scale_factor_est_high_warning, _x.gx5_status_flags.run_mag_bias_est_high_warning, _x.gx5_status_flags.run_ant_offset_correction_est_high_warning, _x.gx5_status_flags.run_mag_hard_iron_est_high_warning, _x.gx5_status_flags.run_mag_soft_iron_est_high_warning, _x.gq7_status_flags.filter_condition, _x.gq7_status_flags.roll_pitch_warning, _x.gq7_status_flags.heading_warning, _x.gq7_status_flags.position_warning, _x.gq7_status_flags.velocity_warning, _x.gq7_status_flags.imu_bias_warning, _x.gq7_status_flags.gnss_clk_warning, _x.gq7_status_flags.antenna_lever_arm_warning, _x.gq7_status_flags.mounting_transform_warning, _x.gq7_status_flags.time_sync_warning, _x.gq7_status_flags.solution_error))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = microstrain_inertial_msgs.msg.MipHeader()
      if self.gx5_status_flags is None:
        self.gx5_status_flags = microstrain_inertial_msgs.msg.MipFilterStatusGx5StatusFlags()
      if self.gq7_status_flags is None:
        self.gq7_status_flags = microstrain_inertial_msgs.msg.MipFilterStatusGq7StatusFlags()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.header.seq, _x.header.header.stamp.secs, _x.header.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 51
      (_x.header.event_source, _x.header.reference_timestamp, _x.header.gps_timestamp.tow, _x.header.gps_timestamp.week_number, _x.filter_state, _x.dynamics_mode, _x.gx5_status_flags.init_no_attitude, _x.gx5_status_flags.init_no_position_velocity, _x.gx5_status_flags.run_imu_unavailable, _x.gx5_status_flags.run_gps_unavailable, _x.gx5_status_flags.run_matrix_singularity, _x.gx5_status_flags.run_position_covariance_warning, _x.gx5_status_flags.run_velocity_covariance_warning, _x.gx5_status_flags.run_attitude_covariance_warning, _x.gx5_status_flags.run_nan_in_solution_warning, _x.gx5_status_flags.run_gyro_bias_est_high_warning, _x.gx5_status_flags.run_accel_bias_est_high_warning, _x.gx5_status_flags.run_gyro_scale_factor_est_high_warning, _x.gx5_status_flags.run_accel_scale_factor_est_high_warning, _x.gx5_status_flags.run_mag_bias_est_high_warning, _x.gx5_status_flags.run_ant_offset_correction_est_high_warning, _x.gx5_status_flags.run_mag_hard_iron_est_high_warning, _x.gx5_status_flags.run_mag_soft_iron_est_high_warning, _x.gq7_status_flags.filter_condition, _x.gq7_status_flags.roll_pitch_warning, _x.gq7_status_flags.heading_warning, _x.gq7_status_flags.position_warning, _x.gq7_status_flags.velocity_warning, _x.gq7_status_flags.imu_bias_warning, _x.gq7_status_flags.gnss_clk_warning, _x.gq7_status_flags.antenna_lever_arm_warning, _x.gq7_status_flags.mounting_transform_warning, _x.gq7_status_flags.time_sync_warning, _x.gq7_status_flags.solution_error,) = _get_struct_BQd3H28B().unpack(str[start:end])
      self.gx5_status_flags.init_no_attitude = bool(self.gx5_status_flags.init_no_attitude)
      self.gx5_status_flags.init_no_position_velocity = bool(self.gx5_status_flags.init_no_position_velocity)
      self.gx5_status_flags.run_imu_unavailable = bool(self.gx5_status_flags.run_imu_unavailable)
      self.gx5_status_flags.run_gps_unavailable = bool(self.gx5_status_flags.run_gps_unavailable)
      self.gx5_status_flags.run_matrix_singularity = bool(self.gx5_status_flags.run_matrix_singularity)
      self.gx5_status_flags.run_position_covariance_warning = bool(self.gx5_status_flags.run_position_covariance_warning)
      self.gx5_status_flags.run_velocity_covariance_warning = bool(self.gx5_status_flags.run_velocity_covariance_warning)
      self.gx5_status_flags.run_attitude_covariance_warning = bool(self.gx5_status_flags.run_attitude_covariance_warning)
      self.gx5_status_flags.run_nan_in_solution_warning = bool(self.gx5_status_flags.run_nan_in_solution_warning)
      self.gx5_status_flags.run_gyro_bias_est_high_warning = bool(self.gx5_status_flags.run_gyro_bias_est_high_warning)
      self.gx5_status_flags.run_accel_bias_est_high_warning = bool(self.gx5_status_flags.run_accel_bias_est_high_warning)
      self.gx5_status_flags.run_gyro_scale_factor_est_high_warning = bool(self.gx5_status_flags.run_gyro_scale_factor_est_high_warning)
      self.gx5_status_flags.run_accel_scale_factor_est_high_warning = bool(self.gx5_status_flags.run_accel_scale_factor_est_high_warning)
      self.gx5_status_flags.run_mag_bias_est_high_warning = bool(self.gx5_status_flags.run_mag_bias_est_high_warning)
      self.gx5_status_flags.run_ant_offset_correction_est_high_warning = bool(self.gx5_status_flags.run_ant_offset_correction_est_high_warning)
      self.gx5_status_flags.run_mag_hard_iron_est_high_warning = bool(self.gx5_status_flags.run_mag_hard_iron_est_high_warning)
      self.gx5_status_flags.run_mag_soft_iron_est_high_warning = bool(self.gx5_status_flags.run_mag_soft_iron_est_high_warning)
      self.gq7_status_flags.roll_pitch_warning = bool(self.gq7_status_flags.roll_pitch_warning)
      self.gq7_status_flags.heading_warning = bool(self.gq7_status_flags.heading_warning)
      self.gq7_status_flags.position_warning = bool(self.gq7_status_flags.position_warning)
      self.gq7_status_flags.velocity_warning = bool(self.gq7_status_flags.velocity_warning)
      self.gq7_status_flags.imu_bias_warning = bool(self.gq7_status_flags.imu_bias_warning)
      self.gq7_status_flags.gnss_clk_warning = bool(self.gq7_status_flags.gnss_clk_warning)
      self.gq7_status_flags.antenna_lever_arm_warning = bool(self.gq7_status_flags.antenna_lever_arm_warning)
      self.gq7_status_flags.mounting_transform_warning = bool(self.gq7_status_flags.mounting_transform_warning)
      self.gq7_status_flags.time_sync_warning = bool(self.gq7_status_flags.time_sync_warning)
      self.gq7_status_flags.solution_error = bool(self.gq7_status_flags.solution_error)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_BQd3H28B = None
def _get_struct_BQd3H28B():
    global _struct_BQd3H28B
    if _struct_BQd3H28B is None:
        _struct_BQd3H28B = struct.Struct("<BQd3H28B")
    return _struct_BQd3H28B
