# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from microstrain_inertial_msgs/MipFilterStatusGq7StatusFlags.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class MipFilterStatusGq7StatusFlags(genpy.Message):
  _md5sum = "1db9853b9f08ade89304b0b0fc0f9df7"
  _type = "microstrain_inertial_msgs/MipFilterStatusGq7StatusFlags"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Message definition for the Status Flags (GQ7, CV7, etc.) field of https://s3.amazonaws.com/files.microstrain.com/GQ7+User+Manual/external_content/dcp/Data/filter_data/data/mip_field_filter_status.htm?Highlight=filter%20status
#   Note: This message will never be published on it's own, only included in other messages.

uint8 filter_condition  # See FILTER_CONDITION_* enums for possible values
bool  roll_pitch_warning
bool  heading_warning
bool  position_warning
bool  velocity_warning
bool  imu_bias_warning
bool  gnss_clk_warning
bool  antenna_lever_arm_warning
bool  mounting_transform_warning
bool  time_sync_warning  # No time synchronization pulse detected
bool  solution_error  # This includes all bits between 12 and 15, if any of them are set there is a GQ7 solution error

# Possible values for filter_condition when the connected device is a prospect device (GQ7, CV7, etc)
uint8 FILTER_CONDITION_STABLE     = 1
uint8 FILTER_CONDITION_CONVERGING = 2
uint8 FILTER_CONDITION_UNSTABLE   = 3"""
  # Pseudo-constants
  FILTER_CONDITION_STABLE = 1
  FILTER_CONDITION_CONVERGING = 2
  FILTER_CONDITION_UNSTABLE = 3

  __slots__ = ['filter_condition','roll_pitch_warning','heading_warning','position_warning','velocity_warning','imu_bias_warning','gnss_clk_warning','antenna_lever_arm_warning','mounting_transform_warning','time_sync_warning','solution_error']
  _slot_types = ['uint8','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       filter_condition,roll_pitch_warning,heading_warning,position_warning,velocity_warning,imu_bias_warning,gnss_clk_warning,antenna_lever_arm_warning,mounting_transform_warning,time_sync_warning,solution_error

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MipFilterStatusGq7StatusFlags, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.filter_condition is None:
        self.filter_condition = 0
      if self.roll_pitch_warning is None:
        self.roll_pitch_warning = False
      if self.heading_warning is None:
        self.heading_warning = False
      if self.position_warning is None:
        self.position_warning = False
      if self.velocity_warning is None:
        self.velocity_warning = False
      if self.imu_bias_warning is None:
        self.imu_bias_warning = False
      if self.gnss_clk_warning is None:
        self.gnss_clk_warning = False
      if self.antenna_lever_arm_warning is None:
        self.antenna_lever_arm_warning = False
      if self.mounting_transform_warning is None:
        self.mounting_transform_warning = False
      if self.time_sync_warning is None:
        self.time_sync_warning = False
      if self.solution_error is None:
        self.solution_error = False
    else:
      self.filter_condition = 0
      self.roll_pitch_warning = False
      self.heading_warning = False
      self.position_warning = False
      self.velocity_warning = False
      self.imu_bias_warning = False
      self.gnss_clk_warning = False
      self.antenna_lever_arm_warning = False
      self.mounting_transform_warning = False
      self.time_sync_warning = False
      self.solution_error = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_11B().pack(_x.filter_condition, _x.roll_pitch_warning, _x.heading_warning, _x.position_warning, _x.velocity_warning, _x.imu_bias_warning, _x.gnss_clk_warning, _x.antenna_lever_arm_warning, _x.mounting_transform_warning, _x.time_sync_warning, _x.solution_error))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 11
      (_x.filter_condition, _x.roll_pitch_warning, _x.heading_warning, _x.position_warning, _x.velocity_warning, _x.imu_bias_warning, _x.gnss_clk_warning, _x.antenna_lever_arm_warning, _x.mounting_transform_warning, _x.time_sync_warning, _x.solution_error,) = _get_struct_11B().unpack(str[start:end])
      self.roll_pitch_warning = bool(self.roll_pitch_warning)
      self.heading_warning = bool(self.heading_warning)
      self.position_warning = bool(self.position_warning)
      self.velocity_warning = bool(self.velocity_warning)
      self.imu_bias_warning = bool(self.imu_bias_warning)
      self.gnss_clk_warning = bool(self.gnss_clk_warning)
      self.antenna_lever_arm_warning = bool(self.antenna_lever_arm_warning)
      self.mounting_transform_warning = bool(self.mounting_transform_warning)
      self.time_sync_warning = bool(self.time_sync_warning)
      self.solution_error = bool(self.solution_error)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_11B().pack(_x.filter_condition, _x.roll_pitch_warning, _x.heading_warning, _x.position_warning, _x.velocity_warning, _x.imu_bias_warning, _x.gnss_clk_warning, _x.antenna_lever_arm_warning, _x.mounting_transform_warning, _x.time_sync_warning, _x.solution_error))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 11
      (_x.filter_condition, _x.roll_pitch_warning, _x.heading_warning, _x.position_warning, _x.velocity_warning, _x.imu_bias_warning, _x.gnss_clk_warning, _x.antenna_lever_arm_warning, _x.mounting_transform_warning, _x.time_sync_warning, _x.solution_error,) = _get_struct_11B().unpack(str[start:end])
      self.roll_pitch_warning = bool(self.roll_pitch_warning)
      self.heading_warning = bool(self.heading_warning)
      self.position_warning = bool(self.position_warning)
      self.velocity_warning = bool(self.velocity_warning)
      self.imu_bias_warning = bool(self.imu_bias_warning)
      self.gnss_clk_warning = bool(self.gnss_clk_warning)
      self.antenna_lever_arm_warning = bool(self.antenna_lever_arm_warning)
      self.mounting_transform_warning = bool(self.mounting_transform_warning)
      self.time_sync_warning = bool(self.time_sync_warning)
      self.solution_error = bool(self.solution_error)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_11B = None
def _get_struct_11B():
    global _struct_11B
    if _struct_11B is None:
        _struct_11B = struct.Struct("<11B")
    return _struct_11B
