# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from microstrain_inertial_msgs/MipGnssCorrectionsRtkCorrectionsStatus.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import microstrain_inertial_msgs.msg
import std_msgs.msg

class MipGnssCorrectionsRtkCorrectionsStatus(genpy.Message):
  _md5sum = "8009259871395ab958d79d7762565e9d"
  _type = "microstrain_inertial_msgs/MipGnssCorrectionsRtkCorrectionsStatus"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Message definition for the MIP field https://s3.amazonaws.com/files.microstrain.com/GQ7+User+Manual/external_content/dcp/Data/gnss_corrections/data/mip_field_gnss_rtk_corrections_status.htm

# Header containing common information
#   header.frame_id has no meaning in this message
microstrain_inertial_msgs/MipHeader header

# GPS time of week (seconds)
float64 time_of_week

# GPS weeks since 1980 (weeks)
uint16 week_number

# Parsed out version of the Epoch Status bitfield
microstrain_inertial_msgs/MipGnssCorrectionsRtkCorrectionsStatusEpochStatus epoch_status

# Parsed out version of the Dongle Status bitfield
microstrain_inertial_msgs/MipGnssCorrectionsRtkCorrectionsStatusDongleStatus dongle_status

# Latency of last GPS correction (seconds)
float32 gps_correction_latency

# Latency of last GLONASS correction (seconds)
float32 glonass_correction_latency

# Latency of last Galileo correction (seconds)
float32 galileo_correction_latency

# Latency of last Beidou correction (seconds)
float32 beidou_correction_latency

================================================================================
MSG: microstrain_inertial_msgs/MipHeader
# Represents a standard header that all MIP fields should include at the beginning of their message definition
#   Note: This message will never be published on it's own, only included in other messages

# Standard ROS header.
#   header.stamp will always be populated with the ROS time that this message was populated
#   header.frame_id is dependent on the full message definition. Most messages will not use this
std_msgs/Header header

# If the message was triggered by an event, this will be set, otherwise it will be set to 0 (will be 0 most of the time)
# For more information, see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_event_source.htm
uint8 event_source

# Reference timestamp of when the data was sampled if the device supports it. For devices that do not support this, it will always be 0
# For more information, see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_reference_timestamp.htm
uint64 reference_timestamp

# GPS timestamp of when the data was sampled if the device supports it
# For more information, see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_gps_timestamp.htm
# Note that this timestamp may be blank in certain messages, but there will often be equivalent fields in the messages
microstrain_inertial_msgs/MipGpsTimestamp gps_timestamp
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: microstrain_inertial_msgs/MipGpsTimestamp
# Definition of a GPS timestamp.
# For more information see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_gps_timestamp.htm
#   Note: This message will never be published on it's own, only included in other messages

# GPS time of week (seconds)
float64 tow

# GPS Week number since 1980 (weeks)
uint16 week_number
================================================================================
MSG: microstrain_inertial_msgs/MipGnssCorrectionsRtkCorrectionsStatusEpochStatus
# Message definition for the Epoch Status field of https://s3.amazonaws.com/files.microstrain.com/GQ7+User+Manual/external_content/dcp/Data/gnss_corrections/data/mip_field_gnss_rtk_corrections_status.htm?Highlight=rtk%20status
#   Note: This message will never be published on it's own, only included in other messages.

bool antenna_location_received
bool antenna_description_received
bool gps_received
bool galileo_received
bool glonass_received
bool beidou_received
bool using_gps_msm_messages  # Using MSM messages for GPS corrections instead of RTCM messages 1001-1004
bool using_glonass_msm_messages  # Using MSM messages for GLONASS corrections instead of RTCM messages 1009-1012
bool dongle_status_read_failed  # A read of the dongle status was attempted, but failed
================================================================================
MSG: microstrain_inertial_msgs/MipGnssCorrectionsRtkCorrectionsStatusDongleStatus
# Message definition for the Dongle Status field of https://s3.amazonaws.com/files.microstrain.com/GQ7+User+Manual/external_content/dcp/Data/gnss_corrections/data/mip_field_gnss_rtk_corrections_status.htm?Highlight=rtk%20status
#   Note: This message will never be published on it's own, only included in other messages.

# Modem State bits from the Dongle Status field. See MODEM_STATE_* enums for possible values
uint8 modem_state

# Connection Type bits from the Dongle Status field. See CONNECTION_TYPE_* enums for possible values
uint8 connection_type

# RSSI bits from the Dongle Status field. Units are in dBm
int8 rssi

# Signal Quality bits from the Dongle Status field.
# 0-10 indication of signal quality, 0 means unavailable/invalid/not connected, 1 is poor, 10 is excellent.
uint8 signal_quality

# Tower Change Indicator bits from the Dongle Status field.
# 4-bit value that increments each time a cell tower change occurs. Rolls over from 15 to 0.
uint8 tower_change_indicator

# NMEA Timeout Flag bit from the Dongle Status field.
# The device has not received a valid NMEA message from the GQ7 in the past 3 seconds
bool nmea_timeout_flag

# Server Timeout Flag bit from the Dongle Status field.
# The device has not received any communications with the server in the past 3 seconds.
bool server_timeout_flag

# RTCM Timeout Flag bit from the Dongle Status field.
# The device has not received a valid RTCM message from the server in the past 3 seconds.
bool rtcm_timeout_flag

# Device Out of Range Flag bit from the Dongle Status field
# The device's reported position is beyond the server-side configured distance to a base station and will not receive corrections
bool device_out_of_range_flag

# Corrections Unavailable Flag bit from the Dongle Status field
# The server is reporting that corrections are not available given the user's account settings
bool corrections_unavailable_flag

# Possible values for dongle_modem_state
uint8 MODEM_STATE_OFF = 0
uint8 MODEM_STATE_NO_NETWORK = 1
uint8 MODEM_STATE_NETWORK_CONNECTED = 2
uint8 MODEM_STATE_CONFIGURING_DATA_CONTEXT = 3
uint8 MODEM_STATE_ACTIVATING_DATA_CONTEXT = 4
uint8 MODEM_STATE_CONFIGURING_SOCKET = 5
uint8 MODEM_STATE_WAITING_ON_SERVER_HANDSHAKE = 6
uint8 MODEM_STATE_CONNECTED_AND_IDLE = 7
uint8 MODEM_STATE_CONNECTED_AND_STREAMING = 8

# Possible values for dongle_connection_type
uint8 CONNECTION_TYPE_NO_CONNECTION = 0
uint8 CONNECTION_TYPE_CONNECTION_2G = 2
uint8 CONNECTION_TYPE_CONNECTION_3G = 3
uint8 CONNECTION_TYPE_CONNECTION_4G = 4
uint8 CONNECTION_TYPE_CONNECTION_5G = 5"""
  __slots__ = ['header','time_of_week','week_number','epoch_status','dongle_status','gps_correction_latency','glonass_correction_latency','galileo_correction_latency','beidou_correction_latency']
  _slot_types = ['microstrain_inertial_msgs/MipHeader','float64','uint16','microstrain_inertial_msgs/MipGnssCorrectionsRtkCorrectionsStatusEpochStatus','microstrain_inertial_msgs/MipGnssCorrectionsRtkCorrectionsStatusDongleStatus','float32','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,time_of_week,week_number,epoch_status,dongle_status,gps_correction_latency,glonass_correction_latency,galileo_correction_latency,beidou_correction_latency

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MipGnssCorrectionsRtkCorrectionsStatus, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = microstrain_inertial_msgs.msg.MipHeader()
      if self.time_of_week is None:
        self.time_of_week = 0.
      if self.week_number is None:
        self.week_number = 0
      if self.epoch_status is None:
        self.epoch_status = microstrain_inertial_msgs.msg.MipGnssCorrectionsRtkCorrectionsStatusEpochStatus()
      if self.dongle_status is None:
        self.dongle_status = microstrain_inertial_msgs.msg.MipGnssCorrectionsRtkCorrectionsStatusDongleStatus()
      if self.gps_correction_latency is None:
        self.gps_correction_latency = 0.
      if self.glonass_correction_latency is None:
        self.glonass_correction_latency = 0.
      if self.galileo_correction_latency is None:
        self.galileo_correction_latency = 0.
      if self.beidou_correction_latency is None:
        self.beidou_correction_latency = 0.
    else:
      self.header = microstrain_inertial_msgs.msg.MipHeader()
      self.time_of_week = 0.
      self.week_number = 0
      self.epoch_status = microstrain_inertial_msgs.msg.MipGnssCorrectionsRtkCorrectionsStatusEpochStatus()
      self.dongle_status = microstrain_inertial_msgs.msg.MipGnssCorrectionsRtkCorrectionsStatusDongleStatus()
      self.gps_correction_latency = 0.
      self.glonass_correction_latency = 0.
      self.galileo_correction_latency = 0.
      self.beidou_correction_latency = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.header.seq, _x.header.header.stamp.secs, _x.header.header.stamp.nsecs))
      _x = self.header.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_BQdHdH11Bb7B4f().pack(_x.header.event_source, _x.header.reference_timestamp, _x.header.gps_timestamp.tow, _x.header.gps_timestamp.week_number, _x.time_of_week, _x.week_number, _x.epoch_status.antenna_location_received, _x.epoch_status.antenna_description_received, _x.epoch_status.gps_received, _x.epoch_status.galileo_received, _x.epoch_status.glonass_received, _x.epoch_status.beidou_received, _x.epoch_status.using_gps_msm_messages, _x.epoch_status.using_glonass_msm_messages, _x.epoch_status.dongle_status_read_failed, _x.dongle_status.modem_state, _x.dongle_status.connection_type, _x.dongle_status.rssi, _x.dongle_status.signal_quality, _x.dongle_status.tower_change_indicator, _x.dongle_status.nmea_timeout_flag, _x.dongle_status.server_timeout_flag, _x.dongle_status.rtcm_timeout_flag, _x.dongle_status.device_out_of_range_flag, _x.dongle_status.corrections_unavailable_flag, _x.gps_correction_latency, _x.glonass_correction_latency, _x.galileo_correction_latency, _x.beidou_correction_latency))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = microstrain_inertial_msgs.msg.MipHeader()
      if self.epoch_status is None:
        self.epoch_status = microstrain_inertial_msgs.msg.MipGnssCorrectionsRtkCorrectionsStatusEpochStatus()
      if self.dongle_status is None:
        self.dongle_status = microstrain_inertial_msgs.msg.MipGnssCorrectionsRtkCorrectionsStatusDongleStatus()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.header.seq, _x.header.header.stamp.secs, _x.header.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 64
      (_x.header.event_source, _x.header.reference_timestamp, _x.header.gps_timestamp.tow, _x.header.gps_timestamp.week_number, _x.time_of_week, _x.week_number, _x.epoch_status.antenna_location_received, _x.epoch_status.antenna_description_received, _x.epoch_status.gps_received, _x.epoch_status.galileo_received, _x.epoch_status.glonass_received, _x.epoch_status.beidou_received, _x.epoch_status.using_gps_msm_messages, _x.epoch_status.using_glonass_msm_messages, _x.epoch_status.dongle_status_read_failed, _x.dongle_status.modem_state, _x.dongle_status.connection_type, _x.dongle_status.rssi, _x.dongle_status.signal_quality, _x.dongle_status.tower_change_indicator, _x.dongle_status.nmea_timeout_flag, _x.dongle_status.server_timeout_flag, _x.dongle_status.rtcm_timeout_flag, _x.dongle_status.device_out_of_range_flag, _x.dongle_status.corrections_unavailable_flag, _x.gps_correction_latency, _x.glonass_correction_latency, _x.galileo_correction_latency, _x.beidou_correction_latency,) = _get_struct_BQdHdH11Bb7B4f().unpack(str[start:end])
      self.epoch_status.antenna_location_received = bool(self.epoch_status.antenna_location_received)
      self.epoch_status.antenna_description_received = bool(self.epoch_status.antenna_description_received)
      self.epoch_status.gps_received = bool(self.epoch_status.gps_received)
      self.epoch_status.galileo_received = bool(self.epoch_status.galileo_received)
      self.epoch_status.glonass_received = bool(self.epoch_status.glonass_received)
      self.epoch_status.beidou_received = bool(self.epoch_status.beidou_received)
      self.epoch_status.using_gps_msm_messages = bool(self.epoch_status.using_gps_msm_messages)
      self.epoch_status.using_glonass_msm_messages = bool(self.epoch_status.using_glonass_msm_messages)
      self.epoch_status.dongle_status_read_failed = bool(self.epoch_status.dongle_status_read_failed)
      self.dongle_status.nmea_timeout_flag = bool(self.dongle_status.nmea_timeout_flag)
      self.dongle_status.server_timeout_flag = bool(self.dongle_status.server_timeout_flag)
      self.dongle_status.rtcm_timeout_flag = bool(self.dongle_status.rtcm_timeout_flag)
      self.dongle_status.device_out_of_range_flag = bool(self.dongle_status.device_out_of_range_flag)
      self.dongle_status.corrections_unavailable_flag = bool(self.dongle_status.corrections_unavailable_flag)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.header.seq, _x.header.header.stamp.secs, _x.header.header.stamp.nsecs))
      _x = self.header.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_BQdHdH11Bb7B4f().pack(_x.header.event_source, _x.header.reference_timestamp, _x.header.gps_timestamp.tow, _x.header.gps_timestamp.week_number, _x.time_of_week, _x.week_number, _x.epoch_status.antenna_location_received, _x.epoch_status.antenna_description_received, _x.epoch_status.gps_received, _x.epoch_status.galileo_received, _x.epoch_status.glonass_received, _x.epoch_status.beidou_received, _x.epoch_status.using_gps_msm_messages, _x.epoch_status.using_glonass_msm_messages, _x.epoch_status.dongle_status_read_failed, _x.dongle_status.modem_state, _x.dongle_status.connection_type, _x.dongle_status.rssi, _x.dongle_status.signal_quality, _x.dongle_status.tower_change_indicator, _x.dongle_status.nmea_timeout_flag, _x.dongle_status.server_timeout_flag, _x.dongle_status.rtcm_timeout_flag, _x.dongle_status.device_out_of_range_flag, _x.dongle_status.corrections_unavailable_flag, _x.gps_correction_latency, _x.glonass_correction_latency, _x.galileo_correction_latency, _x.beidou_correction_latency))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = microstrain_inertial_msgs.msg.MipHeader()
      if self.epoch_status is None:
        self.epoch_status = microstrain_inertial_msgs.msg.MipGnssCorrectionsRtkCorrectionsStatusEpochStatus()
      if self.dongle_status is None:
        self.dongle_status = microstrain_inertial_msgs.msg.MipGnssCorrectionsRtkCorrectionsStatusDongleStatus()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.header.seq, _x.header.header.stamp.secs, _x.header.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 64
      (_x.header.event_source, _x.header.reference_timestamp, _x.header.gps_timestamp.tow, _x.header.gps_timestamp.week_number, _x.time_of_week, _x.week_number, _x.epoch_status.antenna_location_received, _x.epoch_status.antenna_description_received, _x.epoch_status.gps_received, _x.epoch_status.galileo_received, _x.epoch_status.glonass_received, _x.epoch_status.beidou_received, _x.epoch_status.using_gps_msm_messages, _x.epoch_status.using_glonass_msm_messages, _x.epoch_status.dongle_status_read_failed, _x.dongle_status.modem_state, _x.dongle_status.connection_type, _x.dongle_status.rssi, _x.dongle_status.signal_quality, _x.dongle_status.tower_change_indicator, _x.dongle_status.nmea_timeout_flag, _x.dongle_status.server_timeout_flag, _x.dongle_status.rtcm_timeout_flag, _x.dongle_status.device_out_of_range_flag, _x.dongle_status.corrections_unavailable_flag, _x.gps_correction_latency, _x.glonass_correction_latency, _x.galileo_correction_latency, _x.beidou_correction_latency,) = _get_struct_BQdHdH11Bb7B4f().unpack(str[start:end])
      self.epoch_status.antenna_location_received = bool(self.epoch_status.antenna_location_received)
      self.epoch_status.antenna_description_received = bool(self.epoch_status.antenna_description_received)
      self.epoch_status.gps_received = bool(self.epoch_status.gps_received)
      self.epoch_status.galileo_received = bool(self.epoch_status.galileo_received)
      self.epoch_status.glonass_received = bool(self.epoch_status.glonass_received)
      self.epoch_status.beidou_received = bool(self.epoch_status.beidou_received)
      self.epoch_status.using_gps_msm_messages = bool(self.epoch_status.using_gps_msm_messages)
      self.epoch_status.using_glonass_msm_messages = bool(self.epoch_status.using_glonass_msm_messages)
      self.epoch_status.dongle_status_read_failed = bool(self.epoch_status.dongle_status_read_failed)
      self.dongle_status.nmea_timeout_flag = bool(self.dongle_status.nmea_timeout_flag)
      self.dongle_status.server_timeout_flag = bool(self.dongle_status.server_timeout_flag)
      self.dongle_status.rtcm_timeout_flag = bool(self.dongle_status.rtcm_timeout_flag)
      self.dongle_status.device_out_of_range_flag = bool(self.dongle_status.device_out_of_range_flag)
      self.dongle_status.corrections_unavailable_flag = bool(self.dongle_status.corrections_unavailable_flag)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_BQdHdH11Bb7B4f = None
def _get_struct_BQdHdH11Bb7B4f():
    global _struct_BQdHdH11Bb7B4f
    if _struct_BQdHdH11Bb7B4f is None:
        _struct_BQdHdH11Bb7B4f = struct.Struct("<BQdHdH11Bb7B4f")
    return _struct_BQdHdH11Bb7B4f
