# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from microstrain_inertial_msgs/MipGnssCorrectionsRtkCorrectionsStatusDongleStatus.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class MipGnssCorrectionsRtkCorrectionsStatusDongleStatus(genpy.Message):
  _md5sum = "c6b32ecff25b8d73f86e7e5db3fce5f8"
  _type = "microstrain_inertial_msgs/MipGnssCorrectionsRtkCorrectionsStatusDongleStatus"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Message definition for the Dongle Status field of https://s3.amazonaws.com/files.microstrain.com/GQ7+User+Manual/external_content/dcp/Data/gnss_corrections/data/mip_field_gnss_rtk_corrections_status.htm?Highlight=rtk%20status
#   Note: This message will never be published on it's own, only included in other messages.

# Modem State bits from the Dongle Status field. See MODEM_STATE_* enums for possible values
uint8 modem_state

# Connection Type bits from the Dongle Status field. See CONNECTION_TYPE_* enums for possible values
uint8 connection_type

# RSSI bits from the Dongle Status field. Units are in dBm
int8 rssi

# Signal Quality bits from the Dongle Status field.
# 0-10 indication of signal quality, 0 means unavailable/invalid/not connected, 1 is poor, 10 is excellent.
uint8 signal_quality

# Tower Change Indicator bits from the Dongle Status field.
# 4-bit value that increments each time a cell tower change occurs. Rolls over from 15 to 0.
uint8 tower_change_indicator

# NMEA Timeout Flag bit from the Dongle Status field.
# The device has not received a valid NMEA message from the GQ7 in the past 3 seconds
bool nmea_timeout_flag

# Server Timeout Flag bit from the Dongle Status field.
# The device has not received any communications with the server in the past 3 seconds.
bool server_timeout_flag

# RTCM Timeout Flag bit from the Dongle Status field.
# The device has not received a valid RTCM message from the server in the past 3 seconds.
bool rtcm_timeout_flag

# Device Out of Range Flag bit from the Dongle Status field
# The device's reported position is beyond the server-side configured distance to a base station and will not receive corrections
bool device_out_of_range_flag

# Corrections Unavailable Flag bit from the Dongle Status field
# The server is reporting that corrections are not available given the user's account settings
bool corrections_unavailable_flag

# Possible values for dongle_modem_state
uint8 MODEM_STATE_OFF = 0
uint8 MODEM_STATE_NO_NETWORK = 1
uint8 MODEM_STATE_NETWORK_CONNECTED = 2
uint8 MODEM_STATE_CONFIGURING_DATA_CONTEXT = 3
uint8 MODEM_STATE_ACTIVATING_DATA_CONTEXT = 4
uint8 MODEM_STATE_CONFIGURING_SOCKET = 5
uint8 MODEM_STATE_WAITING_ON_SERVER_HANDSHAKE = 6
uint8 MODEM_STATE_CONNECTED_AND_IDLE = 7
uint8 MODEM_STATE_CONNECTED_AND_STREAMING = 8

# Possible values for dongle_connection_type
uint8 CONNECTION_TYPE_NO_CONNECTION = 0
uint8 CONNECTION_TYPE_CONNECTION_2G = 2
uint8 CONNECTION_TYPE_CONNECTION_3G = 3
uint8 CONNECTION_TYPE_CONNECTION_4G = 4
uint8 CONNECTION_TYPE_CONNECTION_5G = 5"""
  # Pseudo-constants
  MODEM_STATE_OFF = 0
  MODEM_STATE_NO_NETWORK = 1
  MODEM_STATE_NETWORK_CONNECTED = 2
  MODEM_STATE_CONFIGURING_DATA_CONTEXT = 3
  MODEM_STATE_ACTIVATING_DATA_CONTEXT = 4
  MODEM_STATE_CONFIGURING_SOCKET = 5
  MODEM_STATE_WAITING_ON_SERVER_HANDSHAKE = 6
  MODEM_STATE_CONNECTED_AND_IDLE = 7
  MODEM_STATE_CONNECTED_AND_STREAMING = 8
  CONNECTION_TYPE_NO_CONNECTION = 0
  CONNECTION_TYPE_CONNECTION_2G = 2
  CONNECTION_TYPE_CONNECTION_3G = 3
  CONNECTION_TYPE_CONNECTION_4G = 4
  CONNECTION_TYPE_CONNECTION_5G = 5

  __slots__ = ['modem_state','connection_type','rssi','signal_quality','tower_change_indicator','nmea_timeout_flag','server_timeout_flag','rtcm_timeout_flag','device_out_of_range_flag','corrections_unavailable_flag']
  _slot_types = ['uint8','uint8','int8','uint8','uint8','bool','bool','bool','bool','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       modem_state,connection_type,rssi,signal_quality,tower_change_indicator,nmea_timeout_flag,server_timeout_flag,rtcm_timeout_flag,device_out_of_range_flag,corrections_unavailable_flag

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MipGnssCorrectionsRtkCorrectionsStatusDongleStatus, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.modem_state is None:
        self.modem_state = 0
      if self.connection_type is None:
        self.connection_type = 0
      if self.rssi is None:
        self.rssi = 0
      if self.signal_quality is None:
        self.signal_quality = 0
      if self.tower_change_indicator is None:
        self.tower_change_indicator = 0
      if self.nmea_timeout_flag is None:
        self.nmea_timeout_flag = False
      if self.server_timeout_flag is None:
        self.server_timeout_flag = False
      if self.rtcm_timeout_flag is None:
        self.rtcm_timeout_flag = False
      if self.device_out_of_range_flag is None:
        self.device_out_of_range_flag = False
      if self.corrections_unavailable_flag is None:
        self.corrections_unavailable_flag = False
    else:
      self.modem_state = 0
      self.connection_type = 0
      self.rssi = 0
      self.signal_quality = 0
      self.tower_change_indicator = 0
      self.nmea_timeout_flag = False
      self.server_timeout_flag = False
      self.rtcm_timeout_flag = False
      self.device_out_of_range_flag = False
      self.corrections_unavailable_flag = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2Bb7B().pack(_x.modem_state, _x.connection_type, _x.rssi, _x.signal_quality, _x.tower_change_indicator, _x.nmea_timeout_flag, _x.server_timeout_flag, _x.rtcm_timeout_flag, _x.device_out_of_range_flag, _x.corrections_unavailable_flag))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 10
      (_x.modem_state, _x.connection_type, _x.rssi, _x.signal_quality, _x.tower_change_indicator, _x.nmea_timeout_flag, _x.server_timeout_flag, _x.rtcm_timeout_flag, _x.device_out_of_range_flag, _x.corrections_unavailable_flag,) = _get_struct_2Bb7B().unpack(str[start:end])
      self.nmea_timeout_flag = bool(self.nmea_timeout_flag)
      self.server_timeout_flag = bool(self.server_timeout_flag)
      self.rtcm_timeout_flag = bool(self.rtcm_timeout_flag)
      self.device_out_of_range_flag = bool(self.device_out_of_range_flag)
      self.corrections_unavailable_flag = bool(self.corrections_unavailable_flag)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2Bb7B().pack(_x.modem_state, _x.connection_type, _x.rssi, _x.signal_quality, _x.tower_change_indicator, _x.nmea_timeout_flag, _x.server_timeout_flag, _x.rtcm_timeout_flag, _x.device_out_of_range_flag, _x.corrections_unavailable_flag))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 10
      (_x.modem_state, _x.connection_type, _x.rssi, _x.signal_quality, _x.tower_change_indicator, _x.nmea_timeout_flag, _x.server_timeout_flag, _x.rtcm_timeout_flag, _x.device_out_of_range_flag, _x.corrections_unavailable_flag,) = _get_struct_2Bb7B().unpack(str[start:end])
      self.nmea_timeout_flag = bool(self.nmea_timeout_flag)
      self.server_timeout_flag = bool(self.server_timeout_flag)
      self.rtcm_timeout_flag = bool(self.rtcm_timeout_flag)
      self.device_out_of_range_flag = bool(self.device_out_of_range_flag)
      self.corrections_unavailable_flag = bool(self.corrections_unavailable_flag)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2Bb7B = None
def _get_struct_2Bb7B():
    global _struct_2Bb7B
    if _struct_2Bb7B is None:
        _struct_2Bb7B = struct.Struct("<2Bb7B")
    return _struct_2Bb7B
