# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from microstrain_inertial_msgs/MipGnssCorrectionsRtkCorrectionsStatusEpochStatus.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class MipGnssCorrectionsRtkCorrectionsStatusEpochStatus(genpy.Message):
  _md5sum = "88d715db92e6df1db097b1ff798927c2"
  _type = "microstrain_inertial_msgs/MipGnssCorrectionsRtkCorrectionsStatusEpochStatus"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Message definition for the Epoch Status field of https://s3.amazonaws.com/files.microstrain.com/GQ7+User+Manual/external_content/dcp/Data/gnss_corrections/data/mip_field_gnss_rtk_corrections_status.htm?Highlight=rtk%20status
#   Note: This message will never be published on it's own, only included in other messages.

bool antenna_location_received
bool antenna_description_received
bool gps_received
bool galileo_received
bool glonass_received
bool beidou_received
bool using_gps_msm_messages  # Using MSM messages for GPS corrections instead of RTCM messages 1001-1004
bool using_glonass_msm_messages  # Using MSM messages for GLONASS corrections instead of RTCM messages 1009-1012
bool dongle_status_read_failed  # A read of the dongle status was attempted, but failed"""
  __slots__ = ['antenna_location_received','antenna_description_received','gps_received','galileo_received','glonass_received','beidou_received','using_gps_msm_messages','using_glonass_msm_messages','dongle_status_read_failed']
  _slot_types = ['bool','bool','bool','bool','bool','bool','bool','bool','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       antenna_location_received,antenna_description_received,gps_received,galileo_received,glonass_received,beidou_received,using_gps_msm_messages,using_glonass_msm_messages,dongle_status_read_failed

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MipGnssCorrectionsRtkCorrectionsStatusEpochStatus, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.antenna_location_received is None:
        self.antenna_location_received = False
      if self.antenna_description_received is None:
        self.antenna_description_received = False
      if self.gps_received is None:
        self.gps_received = False
      if self.galileo_received is None:
        self.galileo_received = False
      if self.glonass_received is None:
        self.glonass_received = False
      if self.beidou_received is None:
        self.beidou_received = False
      if self.using_gps_msm_messages is None:
        self.using_gps_msm_messages = False
      if self.using_glonass_msm_messages is None:
        self.using_glonass_msm_messages = False
      if self.dongle_status_read_failed is None:
        self.dongle_status_read_failed = False
    else:
      self.antenna_location_received = False
      self.antenna_description_received = False
      self.gps_received = False
      self.galileo_received = False
      self.glonass_received = False
      self.beidou_received = False
      self.using_gps_msm_messages = False
      self.using_glonass_msm_messages = False
      self.dongle_status_read_failed = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_9B().pack(_x.antenna_location_received, _x.antenna_description_received, _x.gps_received, _x.galileo_received, _x.glonass_received, _x.beidou_received, _x.using_gps_msm_messages, _x.using_glonass_msm_messages, _x.dongle_status_read_failed))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 9
      (_x.antenna_location_received, _x.antenna_description_received, _x.gps_received, _x.galileo_received, _x.glonass_received, _x.beidou_received, _x.using_gps_msm_messages, _x.using_glonass_msm_messages, _x.dongle_status_read_failed,) = _get_struct_9B().unpack(str[start:end])
      self.antenna_location_received = bool(self.antenna_location_received)
      self.antenna_description_received = bool(self.antenna_description_received)
      self.gps_received = bool(self.gps_received)
      self.galileo_received = bool(self.galileo_received)
      self.glonass_received = bool(self.glonass_received)
      self.beidou_received = bool(self.beidou_received)
      self.using_gps_msm_messages = bool(self.using_gps_msm_messages)
      self.using_glonass_msm_messages = bool(self.using_glonass_msm_messages)
      self.dongle_status_read_failed = bool(self.dongle_status_read_failed)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_9B().pack(_x.antenna_location_received, _x.antenna_description_received, _x.gps_received, _x.galileo_received, _x.glonass_received, _x.beidou_received, _x.using_gps_msm_messages, _x.using_glonass_msm_messages, _x.dongle_status_read_failed))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 9
      (_x.antenna_location_received, _x.antenna_description_received, _x.gps_received, _x.galileo_received, _x.glonass_received, _x.beidou_received, _x.using_gps_msm_messages, _x.using_glonass_msm_messages, _x.dongle_status_read_failed,) = _get_struct_9B().unpack(str[start:end])
      self.antenna_location_received = bool(self.antenna_location_received)
      self.antenna_description_received = bool(self.antenna_description_received)
      self.gps_received = bool(self.gps_received)
      self.galileo_received = bool(self.galileo_received)
      self.glonass_received = bool(self.glonass_received)
      self.beidou_received = bool(self.beidou_received)
      self.using_gps_msm_messages = bool(self.using_gps_msm_messages)
      self.using_glonass_msm_messages = bool(self.using_glonass_msm_messages)
      self.dongle_status_read_failed = bool(self.dongle_status_read_failed)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_9B = None
def _get_struct_9B():
    global _struct_9B
    if _struct_9B is None:
        _struct_9B = struct.Struct("<9B")
    return _struct_9B
