// Auto-generated. Do not edit!

// (in-package microstrain_inertial_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let MipHeader = require('./MipHeader.js');

//-----------------------------------------------------------

class MipGnssRfErrorDetection {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.rf_band = null;
      this.jamming_state = null;
      this.spoofing_state = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new MipHeader();
      }
      if (initObj.hasOwnProperty('rf_band')) {
        this.rf_band = initObj.rf_band
      }
      else {
        this.rf_band = 0;
      }
      if (initObj.hasOwnProperty('jamming_state')) {
        this.jamming_state = initObj.jamming_state
      }
      else {
        this.jamming_state = 0;
      }
      if (initObj.hasOwnProperty('spoofing_state')) {
        this.spoofing_state = initObj.spoofing_state
      }
      else {
        this.spoofing_state = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type MipGnssRfErrorDetection
    // Serialize message field [header]
    bufferOffset = MipHeader.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [rf_band]
    bufferOffset = _serializer.uint8(obj.rf_band, buffer, bufferOffset);
    // Serialize message field [jamming_state]
    bufferOffset = _serializer.uint8(obj.jamming_state, buffer, bufferOffset);
    // Serialize message field [spoofing_state]
    bufferOffset = _serializer.uint8(obj.spoofing_state, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type MipGnssRfErrorDetection
    let len;
    let data = new MipGnssRfErrorDetection(null);
    // Deserialize message field [header]
    data.header = MipHeader.deserialize(buffer, bufferOffset);
    // Deserialize message field [rf_band]
    data.rf_band = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [jamming_state]
    data.jamming_state = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [spoofing_state]
    data.spoofing_state = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += MipHeader.getMessageSize(object.header);
    return length + 3;
  }

  static datatype() {
    // Returns string type for a message object
    return 'microstrain_inertial_msgs/MipGnssRfErrorDetection';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '66603763c626fad4fae6b3c693611670';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Message definition for the MIP field https://s3.amazonaws.com/files.microstrain.com/GQ7+User+Manual/external_content/dcp/Data/gnss_recv_1/data/mip_field_gnss_rf_error_detection.htm
    
    # Header containing common information
    #   header.frame_id has no meaning in this message
    microstrain_inertial_msgs/MipHeader header
    
    # RF Band of the reported information. See RF_BAND_* enums for possible values
    uint8 rf_band
    
    # GNSS Jamming State (as reported by the GNSS module). See JAMMING_STATE_* enums for possible values
    uint8 jamming_state
    
    # GNSS Spoofing State (as reported by the GNSS module). See SPOOFING_STATE_* enums for possible values
    uint8 spoofing_state
    
    # Enum values for rf_band field
    uint8 RF_BAND_UNKNOWN = 0
    uint8 RF_BAND_L1      = 1
    uint8 RF_BAND_L2      = 2
    uint8 RF_BAND_L5      = 5
    
    # Enum values for jamming_state field
    uint8 JAMMING_STATE_UNKNOWN     = 0
    uint8 JAMMING_STATE_NONE        = 1
    uint8 JAMMING_STATE_PARTIAL     = 2
    uint8 JAMMING_STATE_SIGNIFICANT = 3
    
    # Enum values for spoofing_state field
    uint8 SPOOFING_STATE_UNKNOWN     = 0
    uint8 SPOOFING_STATE_NONE        = 1
    uint8 SPOOFING_STATE_PARTIAL     = 2
    uint8 SPOOFING_STATE_SIGNIFICANT = 3
    ================================================================================
    MSG: microstrain_inertial_msgs/MipHeader
    # Represents a standard header that all MIP fields should include at the beginning of their message definition
    #   Note: This message will never be published on it's own, only included in other messages
    
    # Standard ROS header.
    #   header.stamp will always be populated with the ROS time that this message was populated
    #   header.frame_id is dependent on the full message definition. Most messages will not use this
    std_msgs/Header header
    
    # If the message was triggered by an event, this will be set, otherwise it will be set to 0 (will be 0 most of the time)
    # For more information, see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_event_source.htm
    uint8 event_source
    
    # Reference timestamp of when the data was sampled if the device supports it. For devices that do not support this, it will always be 0
    # For more information, see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_reference_timestamp.htm
    uint64 reference_timestamp
    
    # GPS timestamp of when the data was sampled if the device supports it
    # For more information, see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_gps_timestamp.htm
    # Note that this timestamp may be blank in certain messages, but there will often be equivalent fields in the messages
    microstrain_inertial_msgs/MipGpsTimestamp gps_timestamp
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: microstrain_inertial_msgs/MipGpsTimestamp
    # Definition of a GPS timestamp.
    # For more information see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_gps_timestamp.htm
    #   Note: This message will never be published on it's own, only included in other messages
    
    # GPS time of week (seconds)
    float64 tow
    
    # GPS Week number since 1980 (weeks)
    uint16 week_number
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new MipGnssRfErrorDetection(null);
    if (msg.header !== undefined) {
      resolved.header = MipHeader.Resolve(msg.header)
    }
    else {
      resolved.header = new MipHeader()
    }

    if (msg.rf_band !== undefined) {
      resolved.rf_band = msg.rf_band;
    }
    else {
      resolved.rf_band = 0
    }

    if (msg.jamming_state !== undefined) {
      resolved.jamming_state = msg.jamming_state;
    }
    else {
      resolved.jamming_state = 0
    }

    if (msg.spoofing_state !== undefined) {
      resolved.spoofing_state = msg.spoofing_state;
    }
    else {
      resolved.spoofing_state = 0
    }

    return resolved;
    }
};

// Constants for message
MipGnssRfErrorDetection.Constants = {
  RF_BAND_UNKNOWN: 0,
  RF_BAND_L1: 1,
  RF_BAND_L2: 2,
  RF_BAND_L5: 5,
  JAMMING_STATE_UNKNOWN: 0,
  JAMMING_STATE_NONE: 1,
  JAMMING_STATE_PARTIAL: 2,
  JAMMING_STATE_SIGNIFICANT: 3,
  SPOOFING_STATE_UNKNOWN: 0,
  SPOOFING_STATE_NONE: 1,
  SPOOFING_STATE_PARTIAL: 2,
  SPOOFING_STATE_SIGNIFICANT: 3,
}

module.exports = MipGnssRfErrorDetection;
